package algds.contest;

/**
 * Ermoeglicht den Zugang zu einer Zelle des Labyrinths, ohne
 * jedesmal Level und Koordinaten angeben zu muessen.
 * Enthaelt nicht die Daten der Zelle, sondern leitet die
 * Anfragen an das Level weiter.
 * @author Christian Semrau
 * @see Level
 */
public final class Cell {

/**
 * @see Level.removeBeamer(int, int)
 */
public void removeBeamer() {
	level.removeBeamer(x,y);
}      

/**
 * 
 * @return int
 * @see Level.getBorders(int, int)
 */
public int getBorders() {
	return level.getBorders(x,y);
}      

/**
 * 
 * @return boolean
 * @param direction int
 * @see Level.isBorder(int, int, int)
 */
public boolean isBorder(int direction) {
	return level.isBorder(x,y,direction);
}        

	public Level level;
	public int x;
	public int y;

/**
 * 
 * @param level algds.contest.Level
 * @param x int
 * @param y int
 */
public Cell(Level level, int x, int y) {
	this.level = level;
	this.x = x;
	this.y = y;
	if (x<0 || y<0 || x>=level.getWidth() || y>=level.getHeight())
		throw new IllegalArgumentException("new Cell(Level,"+x+","+y+")");
}

/**
 * 
 * @param b algds.contest.Beamer
 * @see Level.addBeamer(int, int, Beamer)
 */
public void addBeamer(Beamer b) {
	level.addBeamer(x,y,b);
}

/**
 * @see Level.addCellBorder(int, int, int)
 */
public void addCellBorder(int b) {
	level.addCellBorder(x,y,b);
}

/**
 * 
 * @param groesse int
 * @param anzahl int
 * @see Level.addCorn(int, int)
 */
public void addCorn(int groesse, int anzahl) {
	level.addCorn(x,y,groesse,anzahl);
}

/**
 * @See Level.getBeamer(int, int)
 */
public Beamer getBeamer() {
	return level.getBeamer(x,y);
}

/**
 * @see Level.getCorn(int, int)
 */
public int[] getCorn() {
	return level.getCorn(x,y);
}

/**
 * @see Level.getCorn(int, int, int)
 */
public int getCorn(int groesse) {
	return level.getCorn(x,y,groesse);
}

/**
 * @see Level.removeCellBorder(int, int, int)
 */
public void removeCellBorder(int b) {
	level.removeCellBorder(x,y,b);
}

/**
 * 
 * @param groesse int
 * @param anzahl int
 * @see Level.removeCorn(int, int, int, int)
 */
public void removeCorn(int groesse, int anzahl) {
	level.removeCorn(x,y,groesse,anzahl);
}
}