package algds.contest;

import java.awt.*;
import java.awt.event.*;

/**
 * ComponentListener des frameMaze der EngineX.
 * Prueft, ob frameMaze immer noch verankert sein soll.
 * Es wird die Fenstergroesse an die Grenzen des Bildschirms angepasst.
 * @author Christian Semrau
 * @see EngineX#createFrame(java.lang.String,boolean)
 */
public class EngineXfCL extends ComponentAdapter{
	EngineX eng;
	public EngineXfCL(EngineX ENG){
		if (ENG==null) throw new NullPointerException();
		eng = ENG;
	}

	public void componentResized(ComponentEvent ev){
		if (eng.control!=null && !eng.ismoving)
			checkAnchored();
		if (eng.anchored && !eng.ismoving)
			eng.positionFrame();
		if (ControlFrame.engineAutoResize)
			eng.checkSize();
		// nach Groessenveraenderungen komplett neuzeichnen,
		// weil unter Windows die Ausgabe blockiert ist,
		// der Hamster aber weiterlaeuft
		eng.drawMaze();
	}

	public void componentMoved(ComponentEvent ev){
		if (eng.control!=null && !eng.ismoving)
			checkAnchored();
		if (eng.anchored && !eng.ismoving)
			eng.positionFrame();
		if (ControlFrame.engineAutoResize)
			eng.checkSize();
		// nach Verschiebungen komplett neuzeichnen,
		// weil unter Windows die Ausgabe blockiert ist,
		// der Hamster aber weiterlaeuft
		eng.drawMaze();
	}
	void checkAnchored(){
		if (eng.control==null || !eng.control.engineDocking){
			// wenn wir nicht gedockt sind, dann halten wir
			// uns auch nicht mehr fest
			eng.anchored = false;
			return;
		}
		Point controlLoc = eng.control.getLocationOnScreen();
		Dimension controlSize = eng.control.getSize();
		Point myLoc = eng.frameMaze.getLocationOnScreen();

		// wenn frameMaze hoechstens 10 Pixel von einer Ecke
		// des ControlFrame entfernt ist, dann verankern wir
		// das Fenster an dieser Ecke.
		// Wir verwenden die Konstanten aus GridBagConstraints,
		// so brauchen wir uns keinen neuen ausdenken.
		// Wuenschenswert waere noch eine Verankerung mit
		// dem rechten und unteren Rand des frameMaze, so dass
		// das Labyrinth links vom ControlFrame ist.
		int anc = 0;
		if (Math.abs(controlLoc.x - myLoc.x)<=10){
			if(Math.abs(controlLoc.y+controlSize.height - myLoc.y)<=10)
				anc = GridBagConstraints.SOUTHWEST;
			else
			if(Math.abs(controlLoc.y - myLoc.y)<=10)
				anc = GridBagConstraints.NORTHWEST;
		}else
		if (Math.abs(controlLoc.x + controlSize.width - myLoc.x)<=10){
			if(Math.abs(controlLoc.y+controlSize.height - myLoc.y)<=10)
				anc = GridBagConstraints.SOUTHEAST;
			else
			if(Math.abs(controlLoc.y - myLoc.y)<=10)
				anc = GridBagConstraints.NORTHEAST;
		}
		if (anc!=0){
			eng.anchored = true;
			eng.anchor = anc;
		}else
			eng.anchored = false;
	}
}