package algds.contest;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Dialogfenster das Informationen ueber die World anzeigt.
 * @author Kai-Uwe Sattler
 * @see World
 */
public final class MazeAboutBox extends JDialog implements ActionListener {
  JPanel panel1 = new JPanel();
  GridBagLayout gbl = new GridBagLayout();
  JButton button1 = new JButton();
  JLabel imageControl1 = new JLabel();
  ImageIcon imageIcon;
  JLabel label1 = new JLabel();
  JLabel label2 = new JLabel();
  JLabel label3 = new JLabel();
  JLabel label4 = new JLabel();
  JLabel label5 = new JLabel();

  String product = "Programming Contest";
  String program = "";
  String version = ControlFrame.programVersion;
  String copyright1 = "Copyright (c)";
  String copyright2 = "Christian Semrau, Stephan Finn";
  String comments = ControlFrame.programDate;

  public MazeAboutBox(Frame parent, String name) {
	super(parent);
	program = name;
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	try { jbInit();
	} catch(Exception e) { e.printStackTrace(System.out); }
	pack();
  }                

  private void jbInit() throws Exception  {
	imageIcon = new ImageIcon(getClass().getResource("bighamster.gif"));
	this.setTitle("About");
	setResizable(false);
	panel1.setLayout(gbl);

	label1.setText(product + " " + version);
	label2.setText(program);
	label3.setText(copyright1);
	label4.setText(copyright2);
	label5.setText(comments);
	button1.setText("Ok");
	button1.addActionListener(this);
	imageControl1.setIcon(imageIcon);

	panel1.add(imageControl1, new GridBagConstraints(0, 0, 1, 6, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(0, 0, 0, 10), 0, 0));
	panel1.add(label1, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(5, 0, 0, 0), 0, 0));
	panel1.add(label2, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(0, 0, 0, 0), 0, 0));
	panel1.add(label3, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(10, 0, 0, 0), 0, 0));
	panel1.add(label4, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(0, 0, 0, 15), 0, 0));
	panel1.add(label5, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(10, 0, 0, 0), 0, 0));
	panel1.add(button1, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0
	  ,GridBagConstraints.WEST, GridBagConstraints.NONE
	  ,new Insets(10, 0, 5, 0), 0, 0));

	this.getContentPane().add(panel1, null);
  }                    

  protected void processWindowEvent(WindowEvent e) {
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	  cancel();
	}
	super.processWindowEvent(e);
  }              

  void cancel() {
	dispose();
  }              

  public void actionPerformed(ActionEvent e) {
	if (e.getSource() == button1) {
	  cancel();
	}
  }              
}