package algds.contest;

/**
 * Liefert die Schnittstelle zwischen dem Hamster
 * und der Ablaufumgebung. Damit kann der Hamster
 * Befehle ausfuehren, ohne die intern verwendete
 * Datenstruktur zu kennen.
 * <br>Eine Beschreibung der Methoden gibts bei Hamster.
 *
 * @author Kai-Uwe Sattler, Christian Semrau, Stephan Finn
 * @see Hamster
 * @see Constants
 */
public interface MazeEngine extends Constants {
	public boolean atHome();
	public int take(int groesse, int anzahl);
	public int drop(int groesse, int anzahl);
	public int eat(int groesse, int anzahl);
	public boolean forward() throws HamsterDiedException;
	public boolean beamMeUp() throws HamsterDiedException;
	public void turn(int direction) throws HamsterDiedException;
	public int look();
	public int lookCurrent();
	public int getDirection();
	public int getSteps();
	public int getTurns();
	public int getCollisions();
	public int getEnergy();
	public int getPoints();
	public int getHomeLevel();
	public int getHomeX();
	public int getHomeY();
	public int getLevel();
	public int getX();
	public int getY();
	public void log(String msg);
	public int[] getCarriedCorn();
	public int[] getCollectedCorn();
	public int[] getAvailableCorn();
	public int getCarriedCorn(int groesse);
	public int getCollectedCorn(int groesse);
	public int getAvailableCorn(int groesse);
	public boolean verbose();
	public boolean mute();
}