package algds.contest;
import java.io.*;

import java.util.Vector;

public class MazeNames {


    


public static void main(String argv[]) {
	if (argv.length < 2) {
		System.out.println("MazeNames: Stephan Finn, Christian Semrau 2001");
		System.out.println("Usage: MazeNames <mazeDir> <outFile> [depth]");
		System.out.println("depth = recursion depth, 0=no subdirs, -1=unlimited");
		return;
	}
	int depth = 0;
	if (argv.length>=3)
		try{
			depth = Integer.parseInt(argv[2]);
		}catch(NumberFormatException exc){
		}
	writeNames(getMazes(argv[0], "", depth), argv[1]);
}

/**
 * 
 * @return java.lang.String[]
 * @param dir java.lang.String
 * @param depth int
 */
public static Vector getMazes(String dirName, String subdirName, int depth) {
	File f = new File(dirName);
	File[] files = f.listFiles(new FileFilter(){
		public boolean accept(File pathname){
			String name = pathname.getName();
			return pathname.isFile() && (name.endsWith(".maze"));
		}
	});
	if (files==null) return new Vector();
	java.util.Arrays.sort(files);

	File[] subdirs = null;
	if (depth!=0)
		subdirs = f.listFiles(new FileFilter(){
		public boolean accept(File pathname){
			return pathname.isDirectory();
		}
	});

	Vector names = new Vector(files.length);
	String sub = (subdirName=="" ? "" : subdirName+"/");
	for(int i=0; i<files.length; i++){
		String s=sub +files[i].getName();
		int j = s.lastIndexOf('.');
		names.addElement(s.substring(0, j));
	}

	if (subdirs!=null)
	for(int i=0; i<subdirs.length; i++){
		String dir = dirName+"/"+subdirs[i].getName();
		String sub2 = sub + subdirs[i].getName();
		//System.out.println(sub2);
		names.addAll(getMazes(dir, sub2, depth-1));
	}

	return names;
}

public static void writeNames(String[] names, String fileName) {
	try {
		BufferedWriter bw = new BufferedWriter(new FileWriter(fileName));
		for (int i = 0; i < names.length - 1; i++)
			bw.write(names[i] + " ");
		if (names.length>0)
			bw.write(names[names.length - 1]);
		bw.newLine();
		bw.close();
	} catch (IOException ex) {
		System.out.println("File save failed!");
	}
}

public static void writeNames(Vector names, String fileName) {
	try {
		BufferedWriter bw = new BufferedWriter(new FileWriter(fileName));
		for (int i = 0; i < names.size() - 1; i++)
			bw.write(names.elementAt(i) + " ");
		if (names.size()>0)
			bw.write((String)names.elementAt(names.size() - 1));
		bw.newLine();
		bw.close();
	} catch (IOException ex) {
		System.out.println("File save failed!");
	}
}
}