package algds.contest;

/**
 * Aendert die Groesse der Levels.
 * <br>
 * Ein Aendern der Levelgroesse innerhalb der World ist momentan schwierig,
 * weil die EngineX eine feste Levelgroesse fuer die Anzeige verwendet,
 * und diese nicht direkt umgestellt werden kann (das ist auch der Grund
 * dafuer, dass die Zellengroesse erst beim Neuladen geaendert werden kann).
 * Eine Groessenaenderung ausserhalb der World oder waehrend des Speichern
 * oder Ladens ist dagegen moeglich.
 * <br>Creation date: (16.04.01 15:39:27)
 * @author: Christian Semrau
 */
public class MazeResize {
	/** Verzeichnis, in dem das Labyrinth gesucht wird. */
	static String mazeDir = "mazes" + java.io.File.separator;

/**
 * Aufruf: java MazeResize mazeIn mazeOut left right top bottom
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	Maze maze = null;
	int left, right, top, bottom;

	left = 0; right = 0; top = 0; bottom = 0;
	try{
		left  = Integer.parseInt(args[2]);
		right = Integer.parseInt(args[3]);
		top   = Integer.parseInt(args[4]);
		bottom= Integer.parseInt(args[5]);
	}catch(NumberFormatException exc){
		System.out.println("Fehlerhaftes Zahlenformat!");
		help();
		System.exit(1);
	}
	
	try {
		maze = new MazeIO().load(mazeDir + args[0]);
	} catch (Exception e) {
		System.out.println("Cannot load maze: " + e.toString());
		help();
		System.exit(1);
	}

	maze.addBounds(left, right, top, bottom);

	try {
		new MazeIO().save(maze, mazeDir+args[1]);
	} catch (Exception e) {
		System.out.println("Cannot save maze: " + e.toString());
		help();
		System.exit(1);
	}
}

static void help(){
	System.out.println("MazeResize, Aendert die Groesse der Level eines Labyrinths");
	System.out.println("Aufruf: java MazeResize mazeIn mazeOut left right top bottom");
	System.out.println("mazeIn, mazeOut: Labyrinthe, ohne Endung .maze");
	System.out.println("left: >0: Randreihen hinzufuegen, <0: Randreihen entfernen");
}

}
