package algds.contest;

/**
 * Liest und setzt die Properties im ControlFrame.
 * Greift auf die Variablen in {@link ControlFrame} zu, welche auch von der
 * {@link EngineX} verwendet werden.
 * @author Christian Semrau, Stephan Finn
 */
public class PropIO extends PropertiesIO{

public PropIO(Logable LOG){
	super();
	log = LOG;
}

public void copy(){
	ControlFrame.creatorName = creator;
	ControlFrame.engineAutoResize = resize;
	ControlFrame.engineDocking = docking;
	EngineX.SLO_MO = slomo;
	EngineX.showHamsterImg = hamsterimg;
	ControlFrame.systemDialogs = systemdialogs;
	ControlFrame.standardLoader = standardloader;
	ControlFrame.defaultSleep = sleep;
	ControlFrame.defaultCellSize = size;
}

/** Properties laden. */
static void load(Logable log){
	PropIO prop = new PropIO(log);
	if (prop.loadState())
		prop.copy();
}

/** Properties speichern. */
static void save(Logable log){
	PropIO prop = new PropIO(log);
	prop.saveState();
}

}