package algds.contest;
import java.io.*;
import java.util.Date;

/**
 * <br>Creation date: (28.04.01 19:20:26)
 * @author: Christian Semrau
 */
public class RunAll {
/**
 * 
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	String[] arg = new String[4];
	arg[1] = args[0];
	arg[2] = "mf"; // mute Hamster
	arg[3] = "res_"+args[0]+".txt";

	try{
		BufferedWriter bw = new BufferedWriter(new FileWriter(arg[3], false));
		bw.close();
	}catch(Exception exc){
		System.out.println("Exception occured while creating results file:\n"+exc);
	}

	int points = 0, steps = 0, turns = 0, energy = 0, corn = 0, collisions = 0, ate = 0;
	int mazes = 0;

	long startZeit = (new Date()).getTime();

	for(int i=1; i<args.length; i++){
		arg[0] = args[i];
		System.out.println("\n"+arg[0]+" ("+i+"/"+(args.length-1)+")");
		int res = MazeRunner.work(arg);
		if (res==0){
			points += MazeRunner.points;
			steps += MazeRunner.steps;
			turns += MazeRunner.turns;
			energy += MazeRunner.energy;
			corn += MazeRunner.corn;
			collisions += MazeRunner.collisions;
			ate += MazeRunner.ate;
			mazes++;
		}
	}

	long endZeit = (new Date()).getTime();

	System.out.println("TOTAL over "+mazes+" Mazes:");
	System.out.println(
		 "Hamster: "+arg[1]+
		 " / Points: " + points +
		 ", Steps: " + steps +
		 ", Turns: " + turns +
		 ", Corn: " + corn +
		 ", Coll: " + collisions +
		 ", Ate: " + ate +
		 ", Time: " + (endZeit-startZeit)/1000);

	try{
		BufferedWriter bw = new BufferedWriter(new FileWriter(arg[3], true));
		bw.write("TOTAL over "+mazes+" Mazes:");
		bw.newLine();
		bw.write(
			 "Hamster: "+arg[1]+
			 " / Points: " + points +
			 ", Steps: " + steps +
			 ", Turns: " + turns +
			 ", Corn: " + corn +
			 ", Coll: " + collisions +
			 ", Ate: " + ate +
			 ", Time: " + (endZeit-startZeit)/1000);
		bw.newLine();
		bw.close();
	}catch(Exception exc){
		System.out.println("Exception occured while saving results:\n"+exc);
	}
}
}
